SourceDebugExtensionAttribute (Java SE 23 & JDK 23)
Description: declaration: module: java.base, package: java.lang.classfile.attribute, interface: SourceDebugExtensionAttribute
Keywords: java.lang.classfile.attribute.SourceDebugExtensionAttribute interface

# Interface SourceDebugExtensionAttribute

All Superinterfaces:
  `AttributePREVIEW<SourceDebugExtensionAttributePREVIEW>`, `ClassElementPREVIEW`, `ClassFileElementPREVIEW`, `WritableElementPREVIEW<SourceDebugExtensionAttributePREVIEW>`

public sealed interface SourceDebugExtensionAttribute extends AttributePREVIEW<SourceDebugExtensionAttributePREVIEW>, ClassElementPREVIEW
`SourceDebugExtensionAttribute` is a preview API of the Java platform.
Programs can only use `SourceDebugExtensionAttribute` when preview features are enabled.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
Models the `SourceDebugExtension` attribute. Delivered as a `ClassElement`PREVIEW when traversing the elements of a `ClassModel`PREVIEW.

The attribute does not permit multiple instances in a given location. Subsequent occurrence of the attribute takes precedence during the attributed element build or transformation.

The attribute was introduced in the Java SE Platform version 5.0.

Since:
  22

- ## Method Summary

  Modifier and Type
  Method
  Description
  `byte[]`
  `contents()`
  Returns the debug extension payload.
  `static SourceDebugExtensionAttributePREVIEW`
  `of(byte[] contents)`
  Returns a `SourceDebugExtension` attribute.

  ### Methods declared in interface java.lang.classfile.AttributePREVIEW

  `attributeMapper, attributeName`

  ### Methods declared in interface java.lang.classfile.WritableElementPREVIEW

  `writeTo`

- ## Method Details

  - ### contents

    byte[] contents()
    Returns the debug extension payload.
    Returns:
      the debug extension payload

  - ### of

    static SourceDebugExtensionAttributePREVIEW of(byte[] contents)
    Returns a `SourceDebugExtension` attribute.
    Parameters:
      `contents` - the extension contents
    Returns:
      a `SourceDebugExtension` attribute